<?php
    echo $this->Html->script('filtre.js');
    echo $this->Html->css('filtre.css');

    // Bouton du filtre de la liste
    echo $this->Form->button('<span class="fa fa-filter fa-lg"><!----></span>' . __d('responsable', 'responsable.btnFiltrerResponsable'), [
        'type' => 'button',
        'class' => 'btn btn-default-default pull-right',
        'id' => 'filtrage'
    ]);
    
    $filters = $this->request->data;

    unset($filters['sort'], $filters['direction'], $filters['page']);
    if (empty($filters['Filtre'])) {
        unset($filters['Filtre']);
    }
?>

<div id="divFiltrage" <?php if(true === empty($filters)) {echo 'style="display: none;"';}?>>
    <?php echo $this->Form->create('Filtre', ['class' => 'search-form']);?>

    <div class="row">
        <?php
        // Filtrer par entité associée
            echo $this->element('Filtres/Parametrages/organisation_associee', ['options' => $options['organisations']]);
            // Filtrer sur le siret
            echo $this->element('Filtres/Parametrages/siret', ['fieldname' => 'siretstructure', 'options' => $options['siretstructure']]);
        ?>
    </div>

    <br>

    <div class="row">
        <?php
            // Filtrer par raison sociale du co-responsable
            echo $this->element('Filtres/Parametrages/raisonsociale', ['fieldname' => 'raisonsocialestructure', 'options' => $options['raisonsocialestructure']]);
            // Filtrer sur le code APE du co-responsable
            echo $this->element('Filtres/Parametrages/ape', ['fieldname' => 'apestructure', 'options' => $options['apestructure']]);
        ?>
    </div>

    <br>

    <div class="row">
        <?php
            // Filtrer par entité créatrice
            echo $this->element('Filtres/Parametrages/organisation_creatrice', ['options' => $options['organisations']]);
        ?>
    </div>

    <?php echo $this->element('Filtres/Parametrages/buttons');?>
    <?php echo $this->Form->end();?>
</div>

<h3>
    <div class='text-warning'>
        <i class="fa fa-fw fa-exclamation-triangle"></i>
        <?php
            echo __d('responsable', 'responsable.warningTexteExplication')
        ?>
    </div>
</h3>

<?php
    if (!empty($responsables)) {
        $pagination = null;
        
        $this->Paginator->options(
            array( 'url' => Hash::flatten( (array)$this->request->data, '.' ) )
        );
        $pagination = $this->element('pagination');

        echo $pagination;
        ?>

        <fieldset>
            <!--Bouton qui permet de choisir l'ordre de generation pour généré l'extrait de registre  -->
            <div class="pull-left btnAffecterEntite" style="margin-left:25px">
                <button type="button" id="btnAffecterEntite" class="btn btn-default-primary btn_affecterEntite" data-toggle="modal" data-target="#modalAddElementToEntity">
                    <span class="fa fa-link fa-lg"><!----></span>
                    <?php 
                        echo __d('responsable', 'responsable.btnAffecterEntite'); 
                    ?>
                </button>
            </div>
        </fieldset>

        <table class="table ">
            <thead>
                <tr>
                    <!-- checkbox -->
                    <th class="thleft col-md-1">
                        <input id="responsableEntiteCheckbox" type="checkbox" class = "responsableEntiteCheckbox_checkbox" />
                    </th>

                    <!-- Structure -->
                    <th class="thleft col-md-2">
                        <?php echo __d('responsable', 'responsable.titreTableauStructure'); ?>
                    </th>
                    
                    <!--  Responsable -->
                    <th class="thleft col-md-2">
                        <?php echo __d('responsable', 'responsable.titreTableauResponsable'); ?>
                    </th>

                    <!-- Information sur le Dpo -->
                    <th class="thleft col-md-2">
                        <?php echo __d('responsable', 'responsable.titreTableauInfoDPO'); ?>
                    </th>
                    
                    <!-- Entité associée -->
                    <th class="thleft col-md-2">
                        <?php echo __d('responsable', 'responsable.titreTableauEntiteResponsable'); ?>
                    </th>

                    <!-- Actions -->
                    <th class="thleft col-md-1">
                        <?php echo __d('responsable', 'responsable.titreTableauAction'); ?>
                    </th>
                </tr>
            </thead>

            <tbody>
                <?php
                foreach ($responsables as $responsable) {
                    ?>
                    <tr>
                        <!-- Casse à coché pour associer un responsable à une entité -->
                        <td class="tdleft">
                            <input id='checkbox<?php echo $responsable['Responsable']['id']; ?>' type="checkbox" class="responsableEntiteCheckbox" value="<?php echo $responsable['Responsable']['id']; ?>" >
                        </td>

                        <!-- Structure -->
                        <td class="tdleft">
                            <?php
                            echo $responsable['Responsable']['raisonsocialestructure'];

                            echo '<ul><li><strong>Siret : </strong>'.$responsable['Responsable']['siretstructure'].'</li></ul>';

                            $items = Hash::extract($responsable, 'Responsable.telephonestructure');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Téléphone : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.faxstructure');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Fax : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.emailstructure');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>E-mail : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }
                            ?>
                        </td>

                        <!-- Responsable de la structure -->
                        <td class="tdleft">
                            <?php
                            if (empty($responsable['Responsable' ]['nom_complet']) === false) {
                                echo $responsable['Responsable' ]['nom_complet'];
                            }

                            $items = Hash::extract($responsable, 'Responsable.fonctionresponsable');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Fonction : </strong>' . implode('</li><li>', $items) . '</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.telephoneresponsable');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Téléphone : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.emailresponsable');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>E-mail : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }
                            ?>
                        </td>

                        <!-- DPO de la structure -->
                        <td class="tdleft">
                            <?php
                            if (empty($responsable['Responsable' ]['nom_complet_dpo']) === false) {
                                echo $responsable['Responsable' ]['nom_complet_dpo'];
                            }

                            $items = Hash::extract($responsable, 'Responsable.numerocnil_dpo');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Numéro CNIL : </strong>' . implode('</li><li>', $items) . '</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.email_dpo');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>E-mail : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.telephonefixe_dpo');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Téléphone fixe : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }

                            $items = Hash::extract($responsable, 'Responsable.telephoneportable_dpo');
                            if (empty($items) === false) {
                                echo '<ul><li><strong>Téléphone portable : </strong>'.implode('</li><li>', $items).'</li></ul>';
                            }
                            ?>
                        </td>
                        
                        <!-- Entité associée -->
                        <td class="tdleft">
                            <?php
                                $items = Hash::extract($responsable, 'Organisation.{n}.raisonsociale');
                                if (empty($items) === false) {
                                    echo '<ul><li>' . implode('</li><li>', $items) . '</li></ul>';
                                }
                            ?>
                        </td>

                        <!-- Actions -->
                        <td class="tdleft col-md-2">
                            <div class="btn-group">
                                <?php
                                    echo $this->Html->link('<span class="fa fa-eye fa-lg"><!----></span>', [
                                        'controller' => 'responsables',
                                        'action' => 'show',
                                        $responsable['Responsable']['id']
                                            ], [
                                        'class' => 'btn btn-default-default btn-sm my-tooltip',
                                        'title' => __d('responsable', 'responsable.commentaireBtnVisualiserResponsable'),
                                        'escape' => false,
                                    ]);
                                    
                                    if ($this->Session->read('Su') || $responsable['Responsable']['createdbyorganisation'] == $this->Session->read('Organisation.id')) {
                                        echo $this->Html->link('<span class="fa fa-pencil fa-lg"><!----></span>', [
                                            'controller' => 'responsables',
                                            'action' => 'edit',
                                            $responsable['Responsable']['id']
                                                ], [
                                            'class' => 'btn btn-default-default btn-sm my-tooltip',
                                            'title' => __d('responsable', 'responsable.commentaireBtnModifierResponsable'),
                                            'escape' => false,
                                        ]);

                                        if (empty($responsable['Organisation']) && empty($responsable['Fiche'])) {
                                            echo $this->Html->link('<span class="fa fa-trash fa-lg"><!----></span>', [
                                                'controller' => 'responsables',
                                                'action' => 'delete',
                                                $responsable['Responsable']['id']
                                                    ], [
                                                'class' => 'btn btn-default-danger btn-sm my-tooltip',
                                                'escapeTitle' => false,
                                                'title' => __d('responsable', 'responsable.commentaireBtnSupprimerResponsable')
                                            ], __d('responsable', 'responsable.confirmationSupprimerResponsable') . $responsable['Responsable']['raisonsocialestructure'] . ' ?');
                                        }
                                    }
                                ?>
                            </div>
                        </td>
                    </tr>
                    <?php
                }
                ?>
            </tbody>
        </table>
        <?php
        echo $pagination;
    } else {
        ?>
        <div class='text-center'>
            <h3>
                <?php
                echo [] === Hash::filter($filters)
                    ? __d('responsable', 'responsable.textAucunResponsable')
                    : __d('responsable', 'responsable.textFiltreAucunResponsable');
                ?>
            </h3>
        </div>
        <?php
    }
?>
        
<div class="text-center">
    <?php
        echo $this->Html->link('<span class="fa fa-plus-circle fa-lg"><!----></span>'. __d('responsable','responsable.btnAjouterResponsable'), [
            'controller' => 'responsables',
            'action' => 'add'
                ],[
            'class' => 'btn btn-default-primary sender',
            'escapeTitle' => false
        ]);
    ?>
</div>

<?php
echo $this->element('Default/modalAddElementToEntity', [
    'controller' => 'Responsable',
    'modalTitle' => __d('responsable', 'responsable.popupTitreAffecterResponsable'),
    'fieldName' => 'ResponsableOrganisation'
]);
?>

<script type="text/javascript">
// <![CDATA[
    $(document).ready(function () {
        
        $('.responsableEntiteCheckbox')
            .attr('checked', false);
    
        $('#btnAffecterEntite').attr('disabled', true);
    
        // Lors d'action sur une checkbox : responsableEntiteCheckbox
        $("#responsableEntiteCheckbox").change(function () {
            $(".responsableEntiteCheckbox").not(':disabled').prop('checked', $(this).prop('checked'));
            
            if ($(this).is(':checked')) {
                $('#btnAffecterEntite').removeAttr('disabled');
            } else {
                $('#btnAffecterEntite').attr('disabled', true);
            }
        });
        
        $('input[type="checkbox"]').not("#responsableEntiteCheckbox").change(function () {
            $('#responsableEntiteCheckbox').prop('checked', $('input[type="checkbox"]').not('#responsableEntiteCheckbox').not(':disabled').not(':checked').length === 0);
        });
        
        $('input[type="checkbox"]').not("#responsableEntiteCheckbox").click(function() {
            $('#btnAffecterEntite').attr("disabled", !$('input[type="checkbox"]').is(":checked"));
            
            $("input[type='hidden']").remove()
        });
        
        $('#modalAddElementToEntity').on('shown.bs.modal', function () {
            var checkboxes = $('table tbody input[type=checkbox]'),
                hidden, value;

            $(checkboxes).each(function(idx) {
                if ($(checkboxes[idx]).prop('checked') === true) {
                    value = $(checkboxes[idx]).prop('value');
                    hidden = '<input type="hidden" name="data[ResponsableOrganisation][responsable_id][]" value="'+value+'" />';
                    $("#modalAddElementToEntity .modal-body").append(hidden);
                }
            });
        });

        $('#btnSave').attr('disabled', true);
        // Lors d'action sur une menu déroulant : organisation_id
        $("#organisation_id").change(function () {
            if ($("#organisation_id").val() != null) {
                $('#btnSave').removeAttr('disabled');
            } else {
                $('#btnSave').attr('disabled', true);
            }
        });
    });
// ]]>
</script>
